module SemSexpr: SEXPR =
  struct
	type sexpr = Nil | Cons of (sexpr ref) * (sexpr ref) | Node of string	
	exception NotALeaf 
	exception NotACons   	
  	let nil = Nil
  	let cons (x, y) = Cons(ref(x), ref(y))
	let node s = Node s
	let car =  function
	  | Cons(x,y) -> !x
	  | _ -> raise NotACons
	let cdr =  function
	  | Cons(x,y) -> !y
	  | _ -> raise NotACons
	let leaf =  function
	  | Node x -> x
	  | _ -> raise NotALeaf
	let null =  function
	  | Nil -> true
	  | _ -> false
	let atom =  function
	  | Cons(x,y) -> false
	  | _ -> true
        let rplaca =  function
	  | (Cons(x, y), z) -> x := z
	  | (_, _) -> raise NotACons
	let rplacd =  function
	  | (Cons(x, y), z) -> y := z
	  | (_, _) -> raise NotACons
  end